#define DL_ASSTEXT 30
#define DL_OBJTEXT 50                             /* '.    */
#define NSYM 20                                   /* .    */
#define NPOP 6                                    /* .. */
#define NOP  12                                   /* .    */
#include <string.h>                               /*. . */
#include <stdlib.h>                               /*...*/
#include <stdio.h>                                /*.../  */
#include <ctype.h>                                /*.... */

/*
*******      '   
*/

char NFIL [30] = "\x0";

unsigned char PRNMET = 'N';                       /* . */
int I3;                                           /*            */

/*
*****      '     1- 
*/

                                                  /*         .*/
int FDC();                                        /*....DC    */
/*..........................................................................*/
                                                  /*         .*/
int FDS();                                        /*....DS    */
/*..........................................................................*/
                                                  /*         .*/
int FEND();                                       /*....END   */
/*..........................................................................*/
                                                  /*         .*/
int FEQU();                                       /*....EQU   */
/*..........................................................................*/
                                                  /*         .*/
int FSTART();                                     /*....START */
/*..........................................................................*/
                                                  /*         .*/
int FUSING();                                     /*....USING */
/*..........................................................................*/
                                                  /*         .*/
int FRR();                                        /*...RR-. */
/*..........................................................................*/
                                                  /*         .*/
int FRX();                                        /*...RX-. */
/*..........................................................................*/


/*
*****      '     2- 
*/

                                                  /*         .*/
int SDC();                                        /*....DC    */
/*..........................................................................*/
                                                  /*         .*/
int SDS();                                        /*....DS    */
/*..........................................................................*/
                                                  /*         .*/
int SEND();                                       /*....END   */
/*..........................................................................*/
                                                  /*         .*/
int SEQU();                                       /*....EQU   */
/*..........................................................................*/
                                                  /*         .*/
int SSTART();                                     /*....START */
/*..........................................................................*/
                                                  /*         .*/
int SUSING();                                     /*....USING */
/*..........................................................................*/
                                                  /*         .*/
int SRR();                                        /*...RR-. */
/*..........................................................................*/
                                                  /*         .*/
int SRX();                                        /*...RX-. */
/*..........................................................................*/

/*
*******      '    
*/

/*
******* '   ()  
*/

 struct ASSKARTA                                  /*.  */
  {
   unsigned  char METKA    [ 8];                  /*               */
   unsigned  char PROBEL1  [ 1];                  /*-      */
   unsigned  char OPERAC   [ 5];                  /*            */
   unsigned  char PROBEL2  [ 1];                  /*-      */
   unsigned  char OPERAND  [12];                  /*            */
   unsigned  char PROBEL3  [ 1];                  /*       */
   unsigned  char COMM     [52];                  /*         */
  };

/*
*******    .    
*/

 union                                            /* '  */
  {
   unsigned char BUFCARD [80];                    /* ..  */
   struct ASSKARTA STRUCT_BUFCARD;                /* .  */
  } TEK_ISX_KARTA;

/*
*****    (   )
*/

 int CHADR;                                       /*                 */

/*
*****  
*/

 int ITSYM = -1;                                  /*... ..*/
 struct TSYM                                      /*. ..*/
  {
   unsigned char IMSYM [8];                       /*              */
   int           ZNSYM;                           /*         */
   int           DLSYM;                           /*            */
   char          PRPER;                           /*      */
  };

 struct TSYM T_SYM [NSYM];                        /* ..  */

/*
*****   
*/

 struct TMOP                                      /*....*/
  {
   unsigned char MNCOP [5];                       /*        */
   unsigned char CODOP    ;                       /*     */
   unsigned char DLOP     ;                       /*    */
   int (*BXPROG)()        ;                       /*  .*/
  } T_MOP [NOP]  =                                /*' ..*/
    {
     {{'B','A','L','R',' '} , '\x05' , 2 , FRR} , /*           */
     {{'B','C','R',' ',' '} , '\x07' , 2 , FRR} , /*                   */
     {{'S','T',' ',' ',' '} , '\x50' , 4 , FRX} , /*                 */
     {{'L',' ',' ',' ',' '} , '\x58' , 4 , FRX} , /*                */
     {{'A',' ',' ',' ',' '} , '\x5A' , 4 , FRX} , /*                */
     {{'S',' ',' ',' ',' '} , '\x5B' , 4 , FRX} , /*                        */
//     {{'A','H',' ',' ',' '} , '\x4A' , 4 , FRX} , /*                        */
//     {{'S','H',' ',' ',' '} , '\x4B' , 4 , FRX} , /*                        */
     {{'C','V','B',' ',' '} , '\x4F' , 4 , FRX} , /*                        */
//     {{'C','V','D',' ',' '} , '\x4E' , 4 , FRX} , /*                        */
     {{'L','H',' ',' ',' '} , '\x48' , 4 , FRX} , /*                        */
     {{'S','T','H',' ',' '} , '\x40' , 4 , FRX} , /*                        */
//     {{'A','R',' ',' ',' '} , '\x1A' , 2 , FRR} , /*                        */
//     {{'S','R',' ',' ',' '} , '\x1B' , 2 , FRR} , /*                        */
     {{'B','C',' ',' ',' '} , '\x47' , 4 , FRX} , /*                        */
     {{'C','R',' ',' ',' '} , '\x19' , 2 , FRR} , /*                        */
     {{'L','R',' ',' ',' '} , '\x18' , 2 , FRR} , /*                        */
//     {{'M',' ',' ',' ',' '} , '\x5C' , 4 , FRX} , /*                        */


    };

/*
*****  
*/

 struct TPOP                                      /*....e.*/
  {
   unsigned char MNCPOP[5];                       /*  */
   int (*BXPROG) ()       ;                       /*  .*/
  } T_POP [NPOP] =                                /*' .*/
    {
     {{'D','C',' ',' ',' '} , FDC   },            /*           */
     {{'D','S',' ',' ',' '} , FDS   },            /*                   */
     {{'E','N','D',' ',' '} , FEND  },            /*                 */
     {{'E','Q','U',' ',' '} , FEQU  },            /*          */
     {{'S','T','A','R','T'} , FSTART},            /*                        */
     {{'U','S','I','N','G'} , FUSING}             /*                        */
    };

/*
*****   
*/

 struct TBASR                                     /*.....*/
  {
   int SMESH;                                     /*                        */
   char PRDOST;                                   /*                        */
  } T_BASR[15] =                                  /*                        */
    {
     {0x00,'N'},                                  /*           */
     {0x00,'N'},                                  /*                   */
     {0x00,'N'},                                  /*                 */
     {0x00,'N'},                                  /*                 */
     {0x00,'N'},                                  /*               */
     {0x00,'N'},                                  /*                        */
     {0x00,'N'},                                  /*                        */
     {0x00,'N'},                                  /*                        */
     {0x00,'N'},                                  /*                        */
     {0x00,'N'},                                  /*                        */
     {0x00,'N'},                                  /*                        */
     {0x00,'N'},                                  /*                        */
     {0x00,'N'},                                  /*                        */
     {0x00,'N'},                                  /*                        */
     {0x00,'N'}                                   /*                        */
    };

/*
*****       '   ' 
*/

  unsigned char OBJTEXT [DL_OBJTEXT][80];         /* '    */
  int ITCARD = 0;                                 /* .   */

  struct OPRR                                     /*....RR */
   {
    unsigned char OP;                             /*             */
    unsigned char R1R2;                           /*R1 -       */
                                                  /*R2 -       */
   };

  union                                           /* '  */
   {
    unsigned char BUF_OP_RR [2];                  /*          */
    struct OPRR OP_RR;                            /*      */
   } RR;

  struct OPRX                                     /*....RX */
   {
    unsigned char  OP;                            /*             */
    unsigned char  R1X2;                          /*R1 -       */
    unsigned short B2D2;                          /*X2 -       */
                                                  /*B2 - ..2- - */
                                                  /*D2 - ..*/
   };

  union                                           /* '  */
   {
    unsigned char BUF_OP_RX [4];                  /*          */
    struct OPRX OP_RX;                            /*      */
   } RX;

  struct STR_BUF_ESD                              /*.  ESD */
   {
    unsigned char POLE1      ;                    /*   0x02     */
    unsigned char POLE2  [ 3];                    /*  '. */
    unsigned char POLE3  [ 6];                    /*                 */
    unsigned char POLE31 [ 2];                    /*      */
    unsigned char POLE32 [ 2];                    /*                 */
    unsigned char POLE4  [ 2];                    /*.-  . */
    unsigned char IMPR   [ 8];                    /*            */
    unsigned char POLE6      ;                    /*  ESD-      */
    unsigned char ADPRG  [ 3];                    /*.  */
    unsigned char POLE8      ;                    /*                 */
    unsigned char DLPRG  [ 3];                    /*          */
    unsigned char POLE10 [40];                    /*                 */
    unsigned char POLE11 [ 8];                    /*   */
   };

 struct STR_BUF_TXT                               /*.  TXT */
   {
    unsigned char POLE1      ;                    /*   0x02     */
    unsigned char POLE2  [ 3];                    /*  '. */
    unsigned char POLE3      ;                    /*                  */
    unsigned char ADOP   [ 3];                    /*.   */
    unsigned char POLE5  [ 2];                    /*                 */
    unsigned char DLNOP  [ 2];                    /*           */
    unsigned char POLE7  [ 2];                    /*                 */
    unsigned char POLE71 [ 2];                    /* .. */
    unsigned char OPER   [56];                    /*            */
    unsigned char POLE9  [ 8];                    /*   */
   };

struct STR_BUF_END                                /*.  END */
   {
    unsigned char POLE1      ;                    /*   0x02     */
    unsigned char POLE2  [ 3];                    /*  '. */
    unsigned char POLE3  [68];                    /*                 */
    unsigned char POLE9  [ 8];                    /*   */
   };

  union                                           /* '  */
   {
    struct STR_BUF_ESD STR_ESD;                   /*         */
    unsigned char BUF_ESD [80];                   /*  ESD         */
   } ESD;


  union                                           /* '  */
   {
    struct STR_BUF_TXT STR_TXT;                   /*         */
    unsigned char BUF_TXT [80];                   /*  TXT         */
   } TXT;

  union                                           /* '  */
   {
    struct STR_BUF_END STR_END;                   /*         */
    unsigned char BUF_END [80];                   /*  ESD         */
   } END;


/*
*******      ' ,   1- 
*/

int FDC()                                         /*....DC    */
 {
  if ( PRNMET == 'Y' )                            /* .DC .,*/
   {                                              /*:                     */
    if                                            /*   DC */
     (                                            /*     */
      TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND[0]=='F'/*  F,     */
     )                                            /* :             */
     {
      T_SYM[ITSYM].DLSYM = 4;                     /*  . . =  4, */
      T_SYM[ITSYM].PRPER = 'R';                   /*  ,..='R' */
      if ( CHADR % 4 )                            /*  ,  CHADR  .*/
       {                                          /*    , : */
        CHADR = (CHADR /4 + 1) * 4;               /*   .CHADR  .. */
        T_SYM[ITSYM].ZNSYM = CHADR;               /*   .  .. */
       }
      PRNMET = 'N';                               /*   PRNMET .'N'*/
      CHADR+= 4;
     }
    else if                                       /*   DC */
     (                                            /*     */
      TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND[0]=='H'/*  H,     */
     )                                            /* :             */
     {
      T_SYM[ITSYM].DLSYM = 2;                     /*  . . =  2, */
      T_SYM[ITSYM].PRPER = 'R';                   /*  ,..='R' */
      if ( CHADR % 4 )                            /*  ,  CHADR  .*/
       {                                          /*    , */
        CHADR = (CHADR /4 + 1) * 4;               /*  .CHADR  ..  */
        T_SYM[ITSYM].ZNSYM = CHADR;               /*  .  ..  */
       }
      PRNMET = 'N';                               /*   PRNMET .'N'*/
      CHADR+= 4;
     }
    else if                                       /*   DC */
     (                                            /*     */
      !memcmp (TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND, "PL8", 3) /*  P,   */
     )                                            /* :             */
     {
      T_SYM[ITSYM].DLSYM = 8;                     /*  . . =  2, */
      T_SYM[ITSYM].PRPER = 'R';                   /*  ,..='R' */
      if ( CHADR % 8 )                            /*  ,  CHADR  .*/
       {                                          /*    . , */
        CHADR = (CHADR /8 + 1) * 8;               /*  .CHADR  ..  */
        T_SYM[ITSYM].ZNSYM = CHADR;               /*  .  ..  */
       }
      PRNMET = 'N';                               /*   PRNMET .'N'*/
      CHADR+= 8;
     }
    else
     return (1);                                  /*      */
   }
  else                                            /*  .*/
   {                                              /*:                     */
    if                                            /*   DC */
     (                                            /*     */
      TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND[0]=='F'/*  F,     */
     )                                            /* :             */
     {
      if ( CHADR % 4 )                            /*  ,  CHADR  .*/
       {                                          /*    , : */
        CHADR = (CHADR /4 + 1) * 4;               /*   .CHADR  .. */
       }
      CHADR+= 4;
     }
    else if                                       /*   DC */
     (                                            /*     */
      TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND[0]=='H'/*  H,     */
     )                                            /* :             */
     {
      if ( CHADR % 4 )                            /*  ,  CHADR  .*/
       {                                          /*    , */
        CHADR = (CHADR /4 + 1) * 4;               /*  .CHADR  ..  */
       }
      CHADR+= 4;
     }
    else if                                       /*   DC */
     (                                            /*     */
      !memcmp (TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND, "PL8", 3)  /*  P,   */
     )                                            /* :             */
     {
      if ( CHADR % 8 )                            /*  ,  CHADR  .*/
       {                                          /*    . , */
        CHADR = (CHADR /8 + 1) * 8;               /*  .CHADR  ..  */
       }
      CHADR+= 8;
     }
    else
     return (1);                                  /*      */
   }
  
  return (0);                                     /*  .*/
 }
/*..........................................................................*/
int FDS()                                         /*....DS    */
 {
  return FDC();
 }
/*..........................................................................*/
int FEND()                                        /*....END   */
 {
  return (100);                                   /*  . 1-*/
                                                  /*               */
 }
/*..........................................................................*/
int FEQU()                                        /*....EQU   */
 {
  if                                              /*           */
   (                                              /* DC       */
    TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND[0] =='*' /* . '*',  */
   )                                              /*                      */
    {                                             /*   ..:*/
     T_SYM[ITSYM].ZNSYM = CHADR;                  /*  CHADR   ZNSYM,   */
     T_SYM[ITSYM].DLSYM = 1;                      /*  1   DLSYM,       */
     T_SYM[ITSYM].PRPER = 'R';                    /*  'R'   PRPER     */
    }
  else                                            /* . .*/
    {                                             /*  - .. */
     T_SYM[ITSYM].ZNSYM = atoi (                  /* DC   ZNSYM,       */
      (char*) TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND
                               );
     T_SYM[ITSYM].DLSYM = 1;                      /* 1   DLSYM,        */
     T_SYM[ITSYM].PRPER = 'A';                    /* 'A'   PRPER       */
    }
  PRNMET = 'N';                                   /*.PRNMET .'N' */
  return (0);                                     /* ..  */
 }
/*..........................................................................*/
int FSTART()                                      /*....START */
 {                                                /*CHADR   */
  CHADR =                                         /*        */
       atoi(
       (char*)TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND/* START , */
           );
  if ( CHADR % 8 )                                /*       */
   {                                              /* 8,   */
    CHADR = ( CHADR + ( 8 - CHADR % 8 ) );        /*                 */
   }                                              /*  ..: */
  T_SYM[ITSYM].ZNSYM = CHADR;                     /* CHADR   ZNSYM,    */
  T_SYM[ITSYM].DLSYM = 1;                         /* 1   DLSYM,        */
  T_SYM[ITSYM].PRPER = 'R';                       /* 'R'   PRPER       */
  PRNMET = 'N';                                   /*.PRNMET .'N' */
  return (0);                                     /* .*/
 }
/*..........................................................................*/
int FUSING()                                      /*....USING */
 {
  return (0);                                     /* .*/
 }
/*..........................................................................*/
int FRR()                                         /*...RR-. */
 {
  CHADR = CHADR + 2;                              /* ..  2  */
  if ( PRNMET == 'Y' )                            /*  ., */
   {                                              /*  . :    */
    T_SYM[ITSYM].DLSYM = 2;                       /*  .*/
    T_SYM[ITSYM].PRPER = 'R';                     /*  .*/
   }
  return(0);                                      /*     */
 }
/*..........................................................................*/
int FRX()                                         /*...RX-. */
 {
  CHADR = CHADR + 4;                              /* ..  4  */
  if ( PRNMET == 'Y' )                            /*  ., */
   {                                              /*  . :    */
    T_SYM[ITSYM].DLSYM = 4;                       /*  .*/
    T_SYM[ITSYM].PRPER = 'R';                     /*  .*/
   }
  return(0);                                      /*     */
 }
/*..........................................................................*/

/*
*******      ' ,   2- 
*/

/*    - */
unsigned char PL8_BUFFER[8];

void STXT( int ARG )                              /*..TXT-  */
 {
  char *PTR;                                      /*.-.*/

  PTR = (char *)&CHADR;                           /*  ADOP  */
  TXT.STR_TXT.ADOP[2]  = *PTR;                    /*TXT-       */
  TXT.STR_TXT.ADOP[1]  = *(PTR+1);                /*         */
  TXT.STR_TXT.ADOP[0]  = '\x00';                  /*       */

  if ( ARG == 2 )                                 /*  OPER  */
   {
    memset ( TXT.STR_TXT.OPER , 64 , 4 );
    memcpy ( TXT.STR_TXT.OPER,RR.BUF_OP_RR , 2 ); /*  RR-         */
    TXT.STR_TXT.DLNOP [1] = 2;
   }
  else if ( ARG == 4 )
   {
    memcpy ( TXT.STR_TXT.OPER , RX.BUF_OP_RX , 4);/*  RX-         */
    TXT.STR_TXT.DLNOP [1] = 4;
   }
  else
   {
    memcpy ( TXT.STR_TXT.OPER , PL8_BUFFER , 8); /*    */
    TXT.STR_TXT.DLNOP [1] = 8;
   }

  memcpy (TXT.STR_TXT.POLE9,ESD.STR_ESD.POLE11,8);/*.. */

  memcpy ( OBJTEXT[ITCARD] , TXT.BUF_TXT , 80 );  /* '   */
  CHADR = CHADR + ARG;                            /*.  */
  ITCARD += 1;                                    /*.- .-*/
  return;
 }

void swaw (char* src, int n)
{
    char t;
    for (int i = 0; i<n/2; i++)
    {
        t = src[i];
        src[i] = src[n-i-1];
        src[n-i-1] = t;
    }
}

int SDC()                                         /*....DC    */
{
  char *RAB;                                      /*       */

  if (!memcmp(TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND, "F'", 2))
  {
     /*    */

     /*  . c .RAB       */
     RAB=strtok ((char*)TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND + 2, "'");
     long t = atol (RAB);

     RAB = (char*)RX.BUF_OP_RX;
     memcpy (RAB, &t, 4);
     swaw (RAB, 4);
     
     if (CHADR%4)
     {
        CHADR = ((CHADR >> 2) + 1) << 2;
     }

     STXT (4);
  }
  else if (!memcmp(TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND, "H'", 2))
  {
     /*    */

     /*  . c .RAB       */
     RAB=strtok ((char*)TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND + 2, "'");
     int t = atoi (RAB);

     RAB = (char*)RR.BUF_OP_RR;
     memcpy (RAB, &t, 2);
     swaw (RAB, 2);

     if (CHADR%4)
     {
        CHADR = ((CHADR >> 2) + 1) << 2;
     }

     STXT (2);
  }
  else if (!memcmp(TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND, "PL8'", 4))
  {
     /*   -  */

     /*   */
     memset (PL8_BUFFER, 0, 8);

     /*  . c .RAB       */
     RAB=strtok ((char*)TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND + 4, "'");
     
     /*    */
     PL8_BUFFER[7] = (RAB[0] == '-' ? 0xD : 0xC);      

     /*     */
     int t = 1;
     for (int k = strlen(RAB)-1; k>0; k--, t++)
     {
        if (t%2) PL8_BUFFER[7-t/2] += (RAB[k]-'0') << 4;
        else     PL8_BUFFER[7-t/2] =  (RAB[k]-'0');
     }

     /*  ,    */
     if (RAB[0] != '-')
     {
        if (t%2) PL8_BUFFER[7-t/2] += (RAB[k]-'0') << 4;
        else     PL8_BUFFER[7-t/2] =  (RAB[k]-'0');
     }

     if (CHADR%8)
     {
        CHADR = ((CHADR >> 3) + 1) << 3;
     }

     /*   */
     STXT (8);
  }
  else
  {
     return 1;
  }

  return 0;
}
/*..........................................................................*/
int SDS()                                         /*....DS    */
 {

  RX.OP_RX.OP   = 0;                              /*       */
  RX.OP_RX.R1X2 = 0;                              /* RX.OP_RX          */
  if
    (                                             /*   */
     TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND[0]=='F' /*   F'        */
    )                                             /* :                    */
   RX.OP_RX.B2D2 = 0;                             /* RX.OP_RX.B2D2   */
  else                                            /*                   */
   return (1);                                    /*       */

  STXT (4);                                       /* TXT-  */

  return (0);                                     /*  .*/
 }
/*..........................................................................*/
int SEND()                                        /*....END   */
 {
                                                  /*            */
  memcpy (                                        /*   */
          END.STR_END.POLE9 ,                     /* END -             */
          ESD.STR_ESD.POLE11,                     /*                        */
          8                                       /*                        */
         );                                       /*                        */
  memcpy (                                        /* '   */
          OBJTEXT[ITCARD],                        /*                       */
          END.BUF_END,                            /*                  */
          80                                      /* '              */
         );                                       /*                    */
  ITCARD += 1;                                    /*.- .-*/
  return (100);                                   /*  . 2-*/
                                                  /*               */
 }
/*..........................................................................*/
int SEQU()                                        /*....EQU   */
 {
  return (0);                                     /* ..  */
 }
/*..........................................................................*/
int SSTART()                                      /*....START */
 {
  char *PTR;                                      /*                   */
  char *METKA;                                    /*                 */
  char *METKA1;                                   /*              */
  int J;                                          /*            */
  int RAB;                                        /*                        */

  METKA1 = strtok                                 /* . c .METKA1*/
           (                                      /*   */
    (char*) TEK_ISX_KARTA.STRUCT_BUFCARD.METKA,   /*    */
            " "                                   /*.    */
           );
  for ( J=0; J<=ITSYM; J++ )                      /*   .  */
   {                                              /* . T_SYM  */
                                                  /*  .. *METKA1 */
    METKA = strtok (
                    (char*) T_SYM[J].IMSYM , " "
                   );
    if( !strcmp ( METKA , METKA1 ) )              /*   :      */
     {                                            /*    ..*/
      RAB = CHADR - T_SYM[J].ZNSYM;               /*  . , -*/
      PTR = (char *)&RAB;                         /*      */
      swab ( PTR , PTR , 2 );                     /*    ,  */
      ESD.STR_ESD.DLPRG [0] = 0;                  /*  .  ESD-*/
      ESD.STR_ESD.DLPRG [1] = *PTR;               /*                */
      ESD.STR_ESD.DLPRG [2] = *(PTR + 1);         /*                        */
      CHADR = T_SYM[J].ZNSYM;                     /*.CHADR,   */
                                                  /* .START   */
                                                  /*         */
      PTR = (char *)&CHADR;                       /*  ADPRG */
      ESD.STR_ESD.ADPRG[2]  = *PTR;               /*ESD-       */
      ESD.STR_ESD.ADPRG[1]  = *(PTR+1);           /*         */
      ESD.STR_ESD.ADPRG[0]  = '\x00';             /*       */
      memcpy (                                    /*            */
               ESD.STR_ESD.IMPR ,                 /*          */
               METKA ,                            /*                       */
               strlen ( METKA )                   /*                        */
             );                                   /*                        */
      memcpy (                                    /*   */
               ESD.STR_ESD.POLE11 ,               /* ESD -             */
               METKA ,                            /*                        */
               strlen ( METKA )                   /*                        */
             );                                   /*                        */
      memcpy (                                    /* '   */
               OBJTEXT[ITCARD] ,                  /*                       */
               ESD.BUF_ESD ,                      /*                  */
               80                                 /* '              */
             );                                   /*                    */
      ITCARD += 1;                                /*.- .-*/
      return (0);                                 /* .*/
     }
   }
  return (2);                                     /* .. */
 }
/*..........................................................................*/
int SUSING()                                      /*....USING */
 {
                                                  /*                   */
  char *METKA;                                    /*                 */
  char *METKA1;                                   /*              */
  char *METKA2;                                   /*                        */
  int J;                                          /*                        */
  int NBASRG;                                     /*                        */
  METKA1 = strtok                                 /* . c .METKA1*/
           (                                      /*   */
    (char*) TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND, /*    */
            ","                                   /*.    */
           );
  METKA2 = strtok                                 /* . c .METKA2*/
           (                                      /*   */
            NULL,                                 /*    */
            " "                                   /*.    */
           );
  if ( isalpha ( (int) *METKA2 ) )                /*   */
   {                                              /* , :            */

    for ( J=0; J<=ITSYM; J++ )                    /*   .  */
     {                                            /* . T_SYM  */
                                                  /*  .. *METKA2 */
      METKA = strtok (
                      (char*) T_SYM[J].IMSYM , " "
                     );
      if( !strcmp ( METKA , METKA2 ) )            /*   :      */
       {                                          /*      */
         if ( (NBASRG = T_SYM[J].ZNSYM) <= 0x0f ) /*    NBASRG   .*/
          goto SUSING1;                           /*  NBASRG <= 0x0f  */
                                                  /*  .    */
         else                                     /* :                 */
          return (6);                             /*       */

       }
     }
    return (2);                                   /*..   */
   }
  else                                            /*,   .*/
   {                                              /*  , : */
    NBASRG = atoi ( METKA2 );                     /*    NBASRG  */
    if ( (NBASRG = T_SYM[J].ZNSYM) <= 0x0f )      /* ,  <= 0x0f,:  */
     goto SUSING1;                                /*   .. */
    else                                          /*:                  */
     return (6);                                  /*       */
   }

 SUSING1:                                         /*  . */

  T_BASR [NBASRG - 1].PRDOST = 'Y';               /*  ..  */
  if ( *METKA1 == '*' )                           /*  .- == '*',*/
   {
    T_BASR[NBASRG-1].SMESH = CHADR;               /* .. ==CHADR*/
   }
  else                                            /*:                  */
   {
    for ( J=0; J<=ITSYM; J++ )                    /*   .  */
     {                                            /* . T_SYM  */
                                                  /*  .. *METKA1 */
      METKA = strtok (
                      (char*) T_SYM[J].IMSYM , " "
                     );
      if( !strcmp ( METKA , METKA1 ) )            /*   :      */
       {                                          /*       */
        T_BASR[NBASRG-1].SMESH = T_SYM[J].ZNSYM;  /*        */
       }
     }
    return (2);                                   /* . */
   }
  return (0);                                     /* .*/
 }
/*..........................................................................*/
int SRR()                                         /*...RR-. */
 {
  char *METKA;                                    /*                   */
  char *METKA1;                                   /*                 */
  char *METKA2;                                   /*              */
  unsigned char R1R2;                             /*                        */
  int J;                                          /*                        */
  RR.OP_RR.OP = T_MOP[I3].CODOP;                  /*  */

  METKA1 = strtok                                 /* . c .METKA1*/
           (                                      /*   */
    (char*) TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND, /*    */
            ","                                   /*.    */
           );

  METKA2 = strtok                                 /* . c .METKA2*/
           (                                      /*   */
            NULL,                                 /*    */
            " "                                   /*.    */
           );

  if ( isalpha ( (int) *METKA1 ) )                /*   */
   {                                              /* , :            */
    for ( J=0; J<=ITSYM; J++ )                    /*   .  */
     {                                            /* . T_SYM  */
                                                  /*  .. *METKA1 */
      METKA = strtok (
                      (char*) T_SYM[J].IMSYM , " "
                     );
      if( !strcmp ( METKA , METKA1 ) )            /*   :      */
       {                                          /*       */
         R1R2 = T_SYM[J].ZNSYM << 4;              /*     .*/
         goto SRR1;
       }                                          /*    */
     }
    return(2);                                    /*."'."*/
   }
  else                                            /*,    */
   {                                              /*. .*/
     R1R2 = atoi ( METKA1 ) << 4;                 /*..     */
   }


 SRR1:


  if ( isalpha ( (int) *METKA2 ) )                /*   */
   {                                              /* , :            */
    for ( J=0; J<=ITSYM; J++ )                    /*   .  */
     {                                            /* . T_SYM  */
                                                  /*  .. *2 */
      METKA = strtok (
                      (char*) T_SYM[J].IMSYM , " "
                     );
      if( !strcmp ( METKA , METKA2 ) )            /*   :      */
       {                                          /*       */
         R1R2 = R1R2 + T_SYM[J].ZNSYM;            /*     .*/
         goto SRR2;                               /*                        */
       }                                          /*    */
     }                                            /*                        */
    return(2);                                    /*."'."*/
   }
  else                                            /*,    */
   {                                              /*. .*/
     R1R2 = R1R2 + atoi ( METKA2 );               /*..     */
   }

 SRR2:

  RR.OP_RR.R1R2 = R1R2;                           /* - -*/
                                                  /*                 */

  STXT(2);
  return(0);                                      /*     */
 }

/*..........................................................................*/
int SRX()                                         /*...RX-. */
 {
  char *METKA;                                    /*                   */
  char *METKA1;                                   /*                 */
  char *METKA2;                                   /*              */
  char *PTR;                                      /*                        */
  int  DELTA;                                     /*                        */
  int  ZNSYM;                                     /*                        */
  int  NBASRG;                                    /*                        */
  int J;                                          /*                        */
  int I;                                          /*                        */
  unsigned char R1X2;                             /*                        */
  int B2D2;                                       /*                        */
  RX.OP_RX.OP = T_MOP[I3].CODOP;                  /*  */
  METKA1 = strtok                                 /* . c .METKA1*/
           (                                      /*   */
    (char*) TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAND, /*    */
            ","                                   /*.    */
           );

  METKA2 = strtok                                 /* . c .METKA2*/
           (                                      /*   */
            NULL,                                 /*    */
            " "                                   /*.    */
           );

  if ( isalpha ( (int) *METKA1 ) )                /*   */
   {                                              /* , :            */
    for ( J=0; J<=ITSYM; J++ )                    /*   .  */
     {                                            /* . T_SYM  */
                                                  /*  .. *METKA  */
      METKA = strtok (
                      (char*) T_SYM[J].IMSYM , " "
                     );
      if( !strcmp ( METKA , METKA1 ) )            /*   :      */

       {                                          /*       */
         R1X2 = T_SYM[J].ZNSYM << 4;              /*     .*/
         goto SRX1;
       }                                          /*    */
     }
    return(2);                                    /*."'."*/
   }
  else                                            /*,    */
   {                                              /*. .*/
     R1X2 = atoi ( METKA1 ) << 4;                 /*..     */
   }


 SRX1:


  if ( isalpha ( (int) *METKA2 ) )                /*   */
   {                                              /* , :            */
    for ( J=0; J<=ITSYM; J++ )                    /*   .  */
     {                                            /* . T_SYM  */
                                                  /*  .. *  */
      METKA = strtok (
                      (char*) T_SYM[J].IMSYM , " "
                     );
      if( !strcmp ( METKA , METKA2 ) )            /*   :      */
       {                                          /*   ..: */
        NBASRG = 0;                               /*    .*/
        DELTA  = 0xfff - 1;                       /*     ., */
        ZNSYM  = T_SYM[J].ZNSYM;                  /*   .. */
        for ( I=0; I<15; I++ )                    /*       */
         {                                        /*-   */
          if (                                    /*,  :     */
               T_BASR[I].PRDOST == 'Y'            /* .,      */
              &&                                  /*                       */
               ZNSYM - T_BASR[I].SMESH >= 0       /* ,   */
              &&                                  /* ,    */
               ZNSYM - T_BASR[I].SMESH < DELTA    /*    -*/
             )                                    /*            */
           {
            NBASRG = I + 1;
            DELTA  = ZNSYM - T_BASR[I].SMESH;
           }
         }
        if ( NBASRG == 0 || DELTA > 0xfff )       /* .. .,*/
         return(5);                               /* ..  */
        else                                      /*                   */
         {                                        /*   */
          B2D2 = NBASRG << 12;                    /*    */
          B2D2 = B2D2 + DELTA;                    /*    B2D2   */
          PTR = (char *)&B2D2;                    /*      */
          swab ( PTR , PTR , 2 );                 /*     -*/
          RX.OP_RX.B2D2 = B2D2;
         }
        goto SRX2;                                /*. .   */
       }                                          /*    */
     }
    return(2);                                    /*."'."*/
   }
  else                                            /*,    */
   {                                              /*. .*/
    return(4);                                    /*..     */
   }

 SRX2:

  RX.OP_RX.R1X2 = R1X2;                           /* .  */

  STXT(4);                                        /* TXT-  */
  return(0);                                      /*     */
 }
/*..........................................................................*/
int SOBJFILE()                                    /*..'. */
 {                                                /*                   */
  FILE *fp;                                       /*            */
  int RAB2;                                       /*              */
                                                  /*   -*/
  strcat ( NFIL , "tex" );                        /* '      */
  if ( (fp = fopen ( NFIL , "wb" )) == NULL )     /* ..- */
   return (-7);                                   /*       */
  else                                            /*:                  */
   RAB2 =fwrite (OBJTEXT, 80 , ITCARD , fp);      /*   .*/
  fclose ( fp );                                  /* ' */
  return ( RAB2 );                                /*   */

 }
/*..........................................................................*/
void INITUNION ()
 {

/*
*****                    ESD-
*****                                
*/

  ESD.STR_ESD.POLE1      =  0x02;
  memcpy ( ESD.STR_ESD.POLE2, "ESD", 3 );
  memset ( ESD.STR_ESD.POLE3,  0x40, 6 );
  ESD.STR_ESD.POLE31 [0] = 0x00;
  ESD.STR_ESD.POLE31 [1] = 0x10;
  memset ( ESD.STR_ESD.POLE32, 0x40, 2 );
  ESD.STR_ESD.POLE4  [0] = 0x00;
  ESD.STR_ESD.POLE4  [1] = 0x01;
  memset ( ESD.STR_ESD.IMPR,   0x40, 8 );
  ESD.STR_ESD.POLE6      = 0x00;
  memset ( ESD.STR_ESD.ADPRG,  0x00, 3 );
  ESD.STR_ESD.POLE8      = 0x40;
  memset ( ESD.STR_ESD.DLPRG,  0x00, 3 );
  memset ( ESD.STR_ESD.POLE10, 0x40,40 );
  memset ( ESD.STR_ESD.POLE11, 0x40, 8 );

/*
*****                    TXT-
*****                                
*/

  TXT.STR_TXT.POLE1      =  0x02;
  memcpy ( TXT.STR_TXT.POLE2, "TXT", 3 );
  TXT.STR_TXT.POLE3      =  0x40;
  memset ( TXT.STR_TXT.ADOP,   0x00, 3 );
  memset ( TXT.STR_TXT.POLE5,  0x40, 2 );
  memset ( TXT.STR_TXT.DLNOP,  0X00, 2 );
  memset ( TXT.STR_TXT.POLE7,  0x40, 2 );
  TXT.STR_TXT.POLE71 [0] = 0x00;
  TXT.STR_TXT.POLE71 [1] = 0x01;
  memset ( TXT.STR_TXT.OPER,   0x40,56 );
  memset ( TXT.STR_TXT.POLE9,  0x40, 8 );

/*
*****                    END-
*****                                
*/

  END.STR_END.POLE1      =  0x02;
  memcpy ( END.STR_END.POLE2, "END", 3 );
  memset ( END.STR_END.POLE3,  0x40,68 );
  memset ( END.STR_END.POLE9,  0x40, 8 );

 }

/*..........................................................................*/

void main( int argc, char **argv )                /*        */
 {
   FILE *fp;
   char *ptr = argv [1];
   unsigned char ASSTEXT [DL_ASSTEXT][80];

/*
*******      '  
*/

  int I1 , I2 , RAB;                              /*        */

  INITUNION ();                                   /*    */
                                                  /*    */
                                                  /*   -*/
                                                  /*           */

/*
******                                     *****
*/
/*
*****        ASSTEXT,  -  '
*****          (     BORLANDC++ 2.0)
*/

  strcpy ( NFIL, ptr );

  if ( argc != 2 )

   {
    printf ( "%s\n", "   " );
    return;
   }


  if ( strcmp ( &NFIL [ strlen ( NFIL )-3 ], "ass" ) )

   {
    printf ( "%s\n", "     " );
    return;
   }


  else

   {
    if ( (fp = fopen ( NFIL , "rb" )) == NULL )   /* ..- */
                                                  /*       */
     {
      printf ( "%s\n", "     " );
      return;
     }

    else

     {
      for ( I1 = 0; I1 <= DL_ASSTEXT; I1++ )

       {
        if ( !fread ( ASSTEXT [I1], 80, 1, fp ) )
         {
          if ( feof ( fp ) )
           goto main1;
          else
           {
            printf ( "%s\n", "     ." );
            return;
           }
         }
       }

      printf ( "%s\n", "   ." );
      return;
     }

   }

main1:

   fclose ( fp );
   NFIL [ strlen ( NFIL )-3 ] = '\x0';

/*
*****       
*/

  for ( I1=0; I1 < DL_ASSTEXT; I1++ )             /*   1  */
   {                                              /*                        */
    memcpy ( TEK_ISX_KARTA.BUFCARD , ASSTEXT[I1], /*- .  */
                                             80 );/*                        */
    if (TEK_ISX_KARTA.STRUCT_BUFCARD.METKA [0] == /*    */
                                             ' ') /*                   */
     goto CONT1;                                  /* CONT1,               */
                                                  /*:                  */
    ITSYM += 1;                                   /*   ..TSYM*/
    PRNMET = 'Y';                                 /* ...*/
    memcpy ( T_SYM[ITSYM].IMSYM ,                 /*     */
        TEK_ISX_KARTA.STRUCT_BUFCARD.METKA , 8 ); /*                       */
    T_SYM[ITSYM].ZNSYM = CHADR;                   /*  (..) */

/*
*****          
*/

   CONT1:

    for ( I2=0; I2 < NPOP; I2++ )                 /*  ...*/
     {                                            /* :     */
      if(                                         /*                    */
      !memcmp(TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAC,/*          */
              T_POP[I2].MNCPOP , 5)               /* ,            */
        )                                         /* :                    */
                                                  /*                        */
       { switch ( T_POP[I2].BXPROG () )           /*   . */
         {
          case 0:
           goto CONT2;                            /*          */
          case 1:
           goto ERR1;
          case 100:
           goto CONT3;
         }
       }                                          /*                        */
     }                                            /*                        */

    for ( I3=0; I3 < NOP ; I3++ )                 /*  ....*/
     {                                            /* :    */
      if(                                         /*                    */
      !memcmp(TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAC,/*        */
              T_MOP[I3].MNCOP , 5)                /* ,            */
        )                                         /* :                    */
                                                  /*                        */
       {
         T_MOP[I3].BXPROG ();                     /*   . */
         PRNMET = 'N';                            /*  ..*/
         goto CONT2;                              /*          */
       }
     }

    goto ERR3;                                    /*.' .'*/


 CONT2:
    continue;                                     /*     */
   }                                              /* .         */


/*
******                                     *****
*/

CONT3:

 T_MOP[0].BXPROG  = SRR;                           /*     */
 T_MOP[1].BXPROG  = SRR;                           /*  -*/
 T_MOP[2].BXPROG  = SRX;                           /*     */
 T_MOP[3].BXPROG  = SRX;                           /*         */
 T_MOP[4].BXPROG  = SRX;
 T_MOP[5].BXPROG  = SRX;
 T_MOP[6].BXPROG  = SRX;
 T_MOP[7].BXPROG  = SRX;
 T_MOP[8].BXPROG  = SRX;
 T_MOP[9].BXPROG  = SRX;
 T_MOP[10].BXPROG = SRX;
 T_MOP[11].BXPROG = SRR;



 T_POP[0].BXPROG = SDC;                           /*     */
 T_POP[1].BXPROG = SDS;                           /*  -*/
 T_POP[2].BXPROG = SEND;                          /*  */
 T_POP[3].BXPROG = SEQU;                          /*      */
 T_POP[4].BXPROG = SSTART;
 T_POP[5].BXPROG = SUSING;

  for ( I1=0; I1 < DL_ASSTEXT; I1++ )             /*   1  */
   {                                               /*                        */
    memcpy ( TEK_ISX_KARTA.BUFCARD , ASSTEXT [I1],/*- .  */
                                             80 );/*                        */
/*
*****          
*/

    for ( I2=0; I2 < NPOP; I2++ )                 /*  ...*/
     {                                            /* :     */
      if(                                         /*                    */
      !memcmp(TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAC,/*          */
              T_POP[I2].MNCPOP , 5)               /* ,            */
        )                                         /*                      */
                                                  /*                        */
       { switch ( T_POP[I2].BXPROG () )           /*   . */
         {
          case 0:
           goto CONT4;                            /*          */
          case 100:                               /*      */
           goto CONT5;                            /*'         */
         }
       }                                          /*                        */
     }                                            /*                        */

    for ( I3=0; I3 < NOP ; I3++ )                 /*  ....*/
     {                                            /* :    */
      if(                                         /*                    */
      !memcmp(TEK_ISX_KARTA.STRUCT_BUFCARD.OPERAC,/*        */
              T_MOP[I3].MNCOP , 5)                /*              */
        )                                         /*                      */
                                                  /*                        */
       {
         switch ( T_MOP[I3].BXPROG () )           /*   . */
          {
           case 0:
            goto CONT4;                           /*          */

           case 2:                                /*   */
            goto ERR2;                            /*               */

           case 4:                                /*   */
            goto ERR4;                            /*               */

           case 5:                                /*   */
            goto ERR5;                            /*               */

           case 6:                                /*   */
            goto ERR6;                            /*               */

           case 7:                                /*   */
            goto ERR6;                            /*               */

          }
        }

     }

 CONT4:
   continue;                                      /*     */
   }                                              /* .         */

CONT5:

  if ( ITCARD == (RAB = SOBJFILE ()) )            /*  '    */
                                                  /*  , : */
   printf                                         /*     */
    (                                             /*              */
     "%s\n",
     "  "
    );
  else                                            /*:                  */
   {
    if ( RAB == -7 )
     goto ERR7;
    else
     printf                                       /*     */
      (                                           /*  ' */
       "%s\n",                                    /*                   */
       "   ' "
      );
   }
    return;                                       /* main-.   */

ERR1:
  printf ("%s\n","  ");        /* ..*/
  goto CONT6;

ERR2:
  printf ("%s\n","' ");  /* ..*/
  goto CONT6;

ERR3:
  printf ("%s\n","  ");         /* ..*/
  goto CONT6;

ERR4:
  printf ("%s\n","  ");      /* ..*/
  goto CONT6;

ERR5:
  printf ("%s\n"," ");           /* ..*/
  goto CONT6;

ERR6:
  printf ("%s\n","  ");  /* ..*/
  goto CONT6;

ERR7:
  printf ("%s\n","  '.");/* ..*/
  goto CONT6;


CONT6:
  printf ("%s%d\n","   N ",I1+1);     /* ..*/

 return;
 }                                                /* main-    */
